/*****************************************************************************/
/* td_mod_tree_equal.h : Objet Gtk+
 * td_mod_tree_equal.h : Gtk+ object
 *
 *
 * ToutDoux : Chtit gestionnaire de projet - A littl' project manager
 * Copyright (c) 2000 Philippe Roy
 * Auteur - Author : Philippe Roy <ph_roy@yahoo.com>
 *
 *
 * Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
 * sous les termes de la licence publique gnrale GNU telle qu'elle est publie par
 * la Free Software Foundation ; soit la version 2 de la licence, ou
 * (comme vous voulez) toute version ultrieure.
 *
 * Ce programme est distribu dans l'espoir qu'il sera utile,
 * mais SANS AUCUNE GARANTIE ; mme sans la garantie de
 * COMMERCIALIT ou d'ADQUATION A UN BUT PARTICULIER. Voir la
 * licence publique gnrale GNU pour plus de dtails.
 *
 * Vous devriez avoir reu une copie de la licence publique gnrale GNU
 * avec ce programme ; si ce n'est pas le cas, crivez  la Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/*****************************************************************************/
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>


/*****************************************************************************/
/* Macros */
/*****************************************************************************/
#define TD_TYPE_MOD_TREE_EQUAL (td_mod_tree_equal_get_type ())
#define TD_MOD_TREE_EQUAL(obj) (GTK_CHECK_CAST ((obj), TD_TYPE_MOD_TREE_EQUAL, TdModTreeEqual))
#define TD_MOD_TREE_EQUAL_CLASS(klass) (GTK_CHECK_CLASS_CASTS ((klass), TD_TYPE_MOD_TREE_EQUAL, TdModTreeEqualClass))
#define TD_IS_MOD_TREE_EQUAL(obj) (GTK_CHECK_TYPE ((obj), TD_TYPE_MOD_TREE_EQUAL))
#define TD_IS_MOD_TREE_EQUAL_CLASS(klass) (GTK_CHECK_CLASS_TYPE ((klass), TD_TYPE_MOD_TREE_EQUAL))

/*****************************************************************************/
/* Structure */
/*****************************************************************************/
typedef struct _TdModTreeEqual TdModTreeEqual;
typedef struct _TdModTreeEqualClass TdModTreeEqualClass;

struct _TdModTreeEqual
{
  GtkObject object;
  GList *column;
  GList *value;
};

struct _TdModTreeEqualClass
{
  GtkObjectClass parent_class;
  void (*add) (TdModTreeEqual *mod_tree_equal, int column, gchar *value);
};

/*****************************************************************************/
/* Arguments */
/*****************************************************************************/

/*****************************************************************************/
/* Initialisation */
/*****************************************************************************/
static void td_mod_tree_equal_init (TdModTreeEqual *mod_tree_equal);
static void td_mod_tree_equal_class_init (TdModTreeEqualClass *klass);
GtkType td_mod_tree_equal_get_type (void);
GtkObject *td_mod_tree_equal_new (void);

/*****************************************************************************/
/* Affectations */
/*****************************************************************************/
void td_mod_tree_equal_add (TdModTreeEqual *mod_tree_equal, int column, gchar *value);

/*****************************************************************************/
/* Commandes */
/*****************************************************************************/
gboolean td_mod_tree_equal_test_node (TdModTreeEqual *mod_tree_equal, GtkObject *mod_tree);
gboolean td_mod_tree_equal_test_list (TdModTreeEqual *mod_tree_equal, GList *data);












